%global meadalpha %{nil}
%global meadrel %{nil}
%global version_major 20
%global version_minor 1
%global version_micro 0
%global version_release 2
%global serial 21
%global version_full %{version_major}.%{version_minor}.%{version_micro}.%{version_release}_0
%global commitid mandrel-20.1.0.2.Final
%global commitid1 5.270.0
%global mandrel_version %{version_full}-%{serial}

# Workaround for stripping of debug symbols from static libraries
# see: https://issues.redhat.com/projects/MANDREL/issues/MANDREL-8
%global debug_package %{nil}
%global __brp_strip_static_archive %{nil}

# Mandrel is sensitive to internal changes of the JDK so we need to make sure
# it is compatible with the installed JDK, thus we require a specific
# jdk version to be installed.
%global jdkversion %(rpm -q --qf '%%{VERSION}-%%{RELEASE}' java-11-openjdk || : )
%global jdkepoch %(rpm -q --qf '%%{EPOCH}:' java-11-openjdk || : )
%global jdkdir %{_jvmdir}/java-11-openjdk-%{jdkversion}.%{_arch}
%global mandrel_install_dir %{jdkdir}/lib/svm

%ifarch x86_64
%global install_arch amd64
%endif

Name:    quarkus-mandrel
Version: %{version_full}
Release: %{serial}%{?dist}
Summary: Mandrel
License: GPLv2 with exceptions
URL:     https://github.com/graalvm/mandrel/

Source0: mandrel-%{commitid}.tar.gz
Source1: mx-%{commitid1}.tar.gz

ExclusiveArch: x86_64
BuildRequires: python3
BuildRequires: ninja-build
BuildRequires: java-11-openjdk-static-libs
BuildRequires: quarkus-mandrel-java = %{version}
BuildRequires: libffi-devel
BuildRequires: zlib-devel
Requires: java-11-openjdk-static-libs = %{jdkepoch}%{jdkversion}
Requires: quarkus-mandrel-java = %{version}
Requires: libffi-devel
Requires: zlib-devel
# Post requires alternatives to install tool alternatives
Requires(post):   %{_sbindir}/alternatives
# Postun requires alternatives to uninstall tool alternatives	
Requires(postun): %{_sbindir}/alternatives

%description
%{summary}

%prep

if [ -z "%jdkversion" ]
then
    echo "rpm failed to obtain java-11-openjdk version, check BuildRequires"
    exit 11
fi

%setup -q -n mandrel-%{commitid}

%{__mkdir_p} %{_builddir}/mx
%{__tar} xf %{S:1} -C %{_builddir}/mx --strip-components=1
cd %{_builddir}/mx

%build
export PATH=$PATH:%{_builddir}/mx
export JAVA_HOME=%{jdkdir}
export MX_PYTHON=%{__python3}

cd substratevm
mx build --projects com.oracle.svm.native.jvm.posix
mx build --projects com.oracle.svm.native.libchelper
mx build --only native-image.image-bash

%install
%{__mkdir_p} %{buildroot}/%{mandrel_install_dir}/clibraries/linux-%{install_arch}/include
%{__install} -Dpm0644 substratevm/src/com.oracle.svm.native.libchelper/include/amd64cpufeatures.h %{buildroot}/%{mandrel_install_dir}/clibraries/linux-%{install_arch}/include
%{__install} -Dpm0644 substratevm/src/com.oracle.svm.native.libchelper/include/aarch64cpufeatures.h %{buildroot}/%{mandrel_install_dir}/clibraries/linux-%{install_arch}/include
%{__install} -Dpm0644 substratevm/src/com.oracle.svm.libffi/include/svm_libffi.h %{buildroot}/%{mandrel_install_dir}/clibraries/linux-%{install_arch}/include
%{__install} -Dpm0644 truffle/src/com.oracle.truffle.nfi.native/include/trufflenfi.h %{buildroot}/%{mandrel_install_dir}/clibraries/linux-%{install_arch}/include
%{__install} -Dpm0644 substratevm/mxbuild/linux-%{install_arch}/src/com.oracle.svm.native.libchelper/%{install_arch}/liblibchelper.a %{buildroot}/%{mandrel_install_dir}/clibraries/linux-%{install_arch}
%{__install} -Dpm0644 substratevm/mxbuild/linux-%{install_arch}/src/com.oracle.svm.native.jvm.posix/%{install_arch}/libjvm.a %{buildroot}/%{mandrel_install_dir}/clibraries/linux-%{install_arch}

%{__mkdir} %{buildroot}/%{mandrel_install_dir}/bin
%{__install} -Dpm0755 sdk/mxbuild/linux-%{install_arch}/native-image.image-bash/native-image %{buildroot}/%{mandrel_install_dir}/bin/native-image

%{__mkdir} %{buildroot}/%{jdkdir}/bin
%{__ln_s} ../lib/svm/bin/native-image %{buildroot}/%{jdkdir}/bin/native-image

%{__sed} -i -e 's!EnableJVMCI!EnableJVMCI -Dorg.graalvm.version="%{mandrel_version}" -Dorg.graalvm.config="(Mandrel Distribution)" --upgrade-module-path ${location}/../../jvmci/graal.jar --add-modules "org.graalvm.truffle,org.graalvm.sdk" --module-path ${location}/../../truffle/truffle-api.jar:${location}/../../jvmci/graal-sdk.jar!' \
    %{buildroot}/%{mandrel_install_dir}/bin/native-image

%check
# Check debug symbols in static libraries (smoke test)
export STATIC_LIBS_HOME=%{buildroot}/%{mandrel_install_dir}/clibraries/linux-%{install_arch}/
readelf --debug-dump $STATIC_LIBS_HOME/liblibchelper.a | grep cpuid.c
readelf --debug-dump $STATIC_LIBS_HOME/libjvm.a | grep JvmFuncs.c

%{__cp} -r %{jdkdir} %{_tmppath}/mandrel-test
%{__cp} -nr %{buildroot}/%{jdkdir}/* %{_tmppath}/mandrel-test

pushd %{_tmppath}/mandrel-test
./bin/native-image --version
echo "public class Version{ public static void main(String[] args) {System.out.println(System.getProperty(\"java.runtime.version\"));}}" > Version.java
JDK_VERSION=$(java Version.java)
./bin/native-image --version  | grep -e "^GraalVM Version %{mandrel_version} (Mandrel Distribution) (Java Version ${JDK_VERSION})$"

echo "
public class HelloStrict
{
    public static void main(String[] args)
    {
        System.out.printf(
            \"Hello %1$,.12f %2$,.12f %3$,.12f %n\"
            , StrictMath.cos(0.0)
            , StrictMath.IEEEremainder(3.0, 5.0)
            , StrictMath.IEEEremainder(-16.3, 4.1)
        );
    }
}
" > HelloStrict.java
./bin/javac HelloStrict.java
./bin/java HelloStrict > java.txt
./bin/native-image HelloStrict
./hellostrict > native.txt
diff java.txt native.txt

popd
%{__rm} -rf %{_tmppath}/mandrel-test

%post
alternatives --add-slave javac %{jdkdir}/bin/javac %{_bindir}/native-image native-image %{jdkdir}/bin/native-image

%postun
alternatives --remove-slave javac %{jdkdir}/bin/javac native-image

%files
%{mandrel_install_dir}/clibraries/linux-%{install_arch}/include/amd64cpufeatures.h
%{mandrel_install_dir}/clibraries/linux-%{install_arch}/include/aarch64cpufeatures.h
%{mandrel_install_dir}/clibraries/linux-%{install_arch}/include/svm_libffi.h
%{mandrel_install_dir}/clibraries/linux-%{install_arch}/include/trufflenfi.h
%{mandrel_install_dir}/clibraries/linux-%{install_arch}/liblibchelper.a
%{mandrel_install_dir}/clibraries/linux-%{install_arch}/libjvm.a
%{mandrel_install_dir}/bin/native-image
%{jdkdir}/bin/native-image

%changelog
* Mon Sep 21 2020 cpaas-ops <cpaas-ops@redhat.com> - 20.1.0.2_0-21
Built by CPaaS

* Fri Sep 18 2020 cpaas-ops <cpaas-ops@redhat.com> - 20.1.0.2_0-20
Built by CPaaS

* Fri Sep 18 2020 cpaas-ops <cpaas-ops@redhat.com> - 20.1.0.2_0-19
Built by CPaaS

* Thu Sep 17 2020 cpaas-ops <cpaas-ops@redhat.com> - 20.1.0-18
Built by CPaaS

* Thu Sep 17 2020 cpaas-ops <cpaas-ops@redhat.com> - 20.1.0-17
Built by CPaaS

* Mon Sep 14 2020 cpaas-ops <cpaas-ops@redhat.com> - 20.1.0-16
Built by CPaaS

* Thu Sep 10 2020 cpaas-ops <cpaas-ops@redhat.com> - 20.1.0-15
Built by CPaaS

* Thu Sep 10 2020 cpaas-ops <cpaas-ops@redhat.com> - 20.1.0-3
Built by CPaaS

* Thu Sep 10 2020 Foivos Zakkak <fzakkak@redhat.com> - 20.1.0-2
- Test new mead script

* Wed Sep 09 2020 Foivos Zakkak <fzakkak@redhat.com> - 20.1.0-1
- Test bump serial

* Wed Sep 09 2020 cpaas-ops <cpaas-ops@redhat.com> - 20.1.0-1
Built by CPaaS

* Wed Sep 09 2020 Foivos Zakkak <fzakkak@redhat.com> - 20.1.0-14
- Test serial bump

* Wed Sep 09 2020 cpaas-ops <cpaas-ops@redhat.com> - 20.1.0-14
Built by CPaaS

* Tue Sep 08 2020 cpaas-ops <cpaas-ops@redhat.com> - 20.1.0-14
Built by CPaaS

* Tue Sep 08 2020 Foivos Zakkak <fzakkak@redhat.com> - 20.1.0-14
- Test build with empty src-url

* Tue Sep 08 2020 cpaas-ops <cpaas-ops@redhat.com> - 20.1.0-14
Built by CPaaS

* Tue Sep 08 2020 Foivos Zakkak <fzakkak@redhat.com> - 20.1.0-14
- New version scheme

* Mon Sep 07 2020 cpaas-ops <cpaas-ops@redhat.com> - 20.1.0-14
Built by CPaaS

* Thu Sep 03 2020 Foivos Zakkak <fzakkak@redhat.com> - 20.1.0-13
- Bump version to 20.1.0.2.Final

* Wed Aug 12 2020 Foivos Zakkak <fzakkak@redhat.com> - 20.1.0-12
- Expose full version (i.e. 20.1.0.1.Final) to `native-image --version`

* Tue Aug 11 2020 Foivos Zakkak <fzakkak@redhat.com> - 20.1.0-11
- Bump mandrel to 20.1.0.1.Final
- Bump mx to 5.270.0
- Remove patch for mx (not needed with 5.270.0)

* Fri Jul 17 2020 Foivos Zakkak <fzakkak@redhat.com> - 20.1.0-10
- Bump mandrel to f9289aa21c68cd8e2b32e0666a6ce3d72d5a1172
- Bump java to 11.0.8+10 GA

* Tue Jul 07 2020 Foivos Zakkak <fzakkak@redhat.com> - 20.1.0-9
- Add native-image smoketest in %check
- Add zlib-devel as dependency

* Mon Jul 06 2020 Foivos Zakkak <fzakkak@redhat.com> - 20.1.0-8
- Add -redhat-XXXXX suffix to version and bump mandrel to a12d97cea8b0c447424a8ce0ad0c106e4d7cdfc4

* Wed Jul 01 2020 Severin Gehwolf <sgehwolf@redhat.com> - 20.1.0-7
- Escape %%jdkversion in changelog

* Wed Jul 01 2020 Severin Gehwolf <sgehwolf@redhat.com> - 20.1.0-6
- Revert loosening of java-11-openjdk requirement

* Fri Jun 26 2020 Severin Gehwolf <sgehwolf@redhat.com> - 20.1.0-5
- Rebuild for updated java-11-openjdk.
- Only require precise epoch:version for java-11-openjdk.

* Thu Jun 25 2020 Foivos Zakkak <fzakkak@redhat.com> - 20.1.0-4
- Build with java-11-openjdk instead of labs-openJDK and require java-11-openjdk-static-libs

* Tue Jun 16 2020 Foivos Zakkak <fzakkak@redhat.com> - 20.1.0-3
- Workaround to avoid stripping of debug symbols from static libraries

* Mon Jun 08 2020 Foivos Zakkak <fzakkak@redhat.com> - 20.1.0-2
- Add required aarch64 header files
- Bump Java version

* Fri Jun 05 2020 Foivos Zakkak <fzakkak@redhat.com> - 20.1.0-1
- Move to graalvm/mandrel and bump to 20.1

* Wed Jun 03 2020 Foivos Zakkak <fzakkak@redhat.com> - 19.3.1-9
- Use mx to build native-image and then patch it with sed
- Fix native-image --version to show the correct version instead of dev
- Add check for version

* Tue Jun 02 2020 Foivos Zakkak <fzakkak@redhat.com> - 19.3.1-8
- Add check for %%jdkversion
- Remove obsolete $PRIORITY
- Pin quarkus-mandrel-java version
- Gets java-11-openjdk version programmatically

* Fri May 22 2020 Foivos Zakkak <fzakkak@redhat.com> - 19.3.1-8
- Get the JDK version programmatically

* Wed May 20 2020 Foivos Zakkak <fzakkak@redhat.com> - 19.3.1-7
- Pin java-11-openjdk version to 11.0.6.10-4

* Wed May 20 2020 Foivos Zakkak <fzakkak@redhat.com> - 19.3.1-6
- Fix %post

* Wed May 20 2020 Foivos Zakkak <fzakkak@redhat.com> - 19.3.1-5
- Fix typo

* Wed May 20 2020 Foivos Zakkak <fzakkak@redhat.com> - 19.3.1-4
- Add link to native-image under /usr/bin using alternatives

* Wed May 20 2020 Foivos Zakkak <fzakkak@redhat.com> - 19.3.1-3
- Fix locations variables in sed command

* Wed May 20 2020 Foivos Zakkak <fzakkak@redhat.com> - 19.3.1-2
- Fix spec file

* Fri May 15 2020 Foivos Zakkak <fzakkak@redhat.com> - 19.3.1-1
- Initial commit
